import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Demo extends PApplet {


// check the number of persons that are walking in the calle

int numIn, numOut;
boolean play;
PImage bg, presence;
PImage a, b, c, d, light_oriz, light_vert, start, phone;
boolean checkA, checkB, checkC, checkD, checkPhone;
Person silvia, erika;
String[] path;
int indexPath;

  // music library
Minim minim;
AudioPlayer telephone; 
AudioPlayer walk;
AudioPlayer pickUp;
AudioPlayer ghost;
AudioPlayer audioguida;
AudioPlayer busyPhone;
float silvia_prev_x;
float silvia_prev_y;
float erika_prev_x;
float erika_prev_y;
boolean ora;
PImage bg2,y,n,ok;
PImage giorno, notte;

public void setup(){
  size(655,780);
  background(255);
  imageMode(CENTER);
  play = false;
  bg = loadImage("cartina.png");
  presence = loadImage("cartina_presence.jpg");
  silvia = new Person("silvia.png");
  erika = new Person("erika.png");
  a = loadImage("a.png");
  b = loadImage("b.png");
  c = loadImage("b.png");
  d = loadImage("a.png");
  phone = loadImage("phone.png");
  light_oriz = loadImage("light_oriz.png");
  light_vert = loadImage("light_vert.png");
  start = loadImage("start.png");
  checkA = checkB = checkC = checkD = checkPhone =  true;
  path = new String[1000];
  indexPath = 0;
  // posizioni iniziali
  silvia.x = 160;
  silvia.y=484;
  erika.x=130;
  erika.y=484;
  minim = new Minim(this); // new Minim object  
  telephone = minim.loadFile("telephone.mp3");
  pickUp = minim.loadFile("pickUp.wav");
  ghost = minim.loadFile("ghost.mp3");
  audioguida = minim.loadFile("guida.mp3");
  busyPhone = minim.loadFile("busyphone.mp3");
  ora = false;
  bg2 = loadImage("bg.jpg");
  y = loadImage("y.png");
  n = loadImage("n.png");
  ok = loadImage("ok.png");
  giorno = loadImage("day.png");
  notte = loadImage("night.png");
}

public void draw(){
  
  if(play){
    image(bg,336,400); 
    image(a,300,450);
    image(b,320,450);
    image(c,510,150);
    image(d,530,150);
    checkA();
    checkB();
    checkC();
    checkD();
    checkPhone();
    silvia.drawPerson();
    erika.drawPerson();
    checkIncident();
    
    image(phone,336,320);
    
    if(ora){
      image(notte, width-80, 50);
    }
    else{
      image(giorno, width-80, 50);
    }
    
  }
  else{
    image(start,320,400);
    if(mousePressed){ play = true; }
  }
  
}


public void keyPressed(){


    
      if(ora){
        if(numIn-numOut==1){
          if(silvia.isNearPhone() || erika.isNearPhone()){
            busyPhone.play();
            busyPhone.rewind();
          }
        }
        else{
          if(silvia.isNearPhone() || erika.isNearPhone()){
            audioguida.play();
            audioguida.rewind();
          }
        }
      }
      else{
          if(silvia.isNearPhone() || erika.isNearPhone()){
            audioguida.play();
            audioguida.rewind();
          }
      }
         
}


public void mousePressed(){

  if(mouseX > 530 && mouseX <570 && mouseY > 35 && mouseY < 70){
    ora = false;
  }
  if(mouseX > 590 && mouseX <615 && mouseY > 35 && mouseY < 70){
    ora = true;
  }
  
}

public void pickUpPhone(){

  if(ora){
    if(numIn-numOut==0){
    
    if(!telephone.isPlaying()){
      audioguida.play();
      audioguida.rewind();
    }
    
    }
  }
  else{
    audioguida.play();
    audioguida.rewind();
  }

}

public void checkPhone(){
  if(numIn-numOut==1){
      if(silvia.isNearPhone() || erika.isNearPhone()){
        
        
        if(ora){
          if(checkPhone){
            checkPhone = false;
            println("GHOOOOOOOST !!!"); 
            telephone.play(); 
            telephone.rewind();
          }
        }
      }
      else{ checkPhone = true; }
  }
}

public void checkA(){
  if(silvia.isTouchingA() || erika.isTouchingA()){
    image(light_vert, 300, 490);
    if(checkA){ 
      checkA = false;
      insertPath("A");  
    }
  }
  else{ checkA=true; }
}

public void checkB(){
  if(silvia.isTouchingB() || erika.isTouchingB()){
    image(light_vert, 320, 490);
    if(checkB){ 
      checkB = false;
      insertPath("B");    
    }
  }
  else{ checkB=true; }
}

public void checkC(){
  if(silvia.isTouchingC() || erika.isTouchingC()){
    image(light_vert, 510, 190);
    if(checkC){ 
      checkC = false;
      insertPath("B");  
    }
  }
  else{ checkC=true; }
}

public void checkD(){
  if(silvia.isTouchingD() || erika.isTouchingD()){
    image(light_vert, 530, 190);
    if(checkD){ 
      checkD = false;
      insertPath("A");  
    }
  }
  else{ checkD=true; }
}

public void checkIncident(){
  if(erika.x==silvia.x && erika.y==silvia.y){
    erika.x = erika.x+15;
    erika.y = erika.y+15;
  }
}



class Person
{
  boolean user;
  float x,y;
  PImage img;
  
  Person(String immagine){
      img = loadImage(immagine);
  }

  public void drawPerson(){
    image(img,x,y);
  }
  
  public boolean isTouchingA(){
    if(x>290 && x<310 && y>480 && y<510){ return true; } else { return false; }
  }
  public boolean isTouchingB(){
    if(x>310 && x<330 && y>480 && y<510){ return true; } else { return false; }
  }
  public boolean isTouchingC(){
    if(x>500 && x<520 && y>150 && y<200){ return true; } else { return false; }
  }
  public boolean isTouchingD(){
    if(x>520 && x<540 && y>150 && y<200){ return true; } else { return false; }
  }
  public boolean isNearPhone(){
    if(x>365 && x<400 && y>300 && y<350){ return true; } else { return false; }
  } 
}

  
  


public void insertPath(String x){
  path[indexPath] = x;
  println("path["+indexPath+"] : "+ path[indexPath]);
  indexPath++;
  
  // calcolo entrate ed uscite
  if(indexPath>1){
  if(indexPath%2==0){
    if((path[indexPath-1]=="B") && (path[indexPath-2]=="A")){
      numIn++;  
    }
    if((path[indexPath-1]=="A") && (path[indexPath-2]=="B")){
      numOut++;  
    }
    
  }
  }
  // fine calcolo

}



public void mouseDragged() 
{
  if(mousePressed){
    if((mouseX > silvia.x-20 && mouseX < silvia.x+20) && (mouseY > silvia.y-20 && mouseY < silvia.y+20)){
      silvia.x = mouseX;
      silvia.y = mouseY;
    }
    if((mouseX > erika.x-20 && mouseX < erika.x+20) && (mouseY > erika.y-20 && mouseY < erika.y+20)){
      erika.x = mouseX;
      erika.y = mouseY;
    }
  }
  
}



  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ffffff", "Demo" });
  }
}
