
// check the number of persons that are walking in the calle

int numIn, numOut;
boolean play;
PImage bg, presence;
PImage a, b, c, d, light_oriz, light_vert, start, phone;
boolean checkA, checkB, checkC, checkD, checkPhone;
Person silvia, erika;
String[] path;
int indexPath;

import ddf.minim.*;  // music library
Minim minim;
AudioPlayer telephone; 
AudioPlayer walk;
AudioPlayer pickUp;
AudioPlayer ghost;
AudioPlayer audioguida;
AudioPlayer busyPhone;
float silvia_prev_x;
float silvia_prev_y;
float erika_prev_x;
float erika_prev_y;
boolean ora;
PImage bg2,y,n,ok;
PImage giorno, notte;

void setup(){
  size(655,780);
  background(255);
  imageMode(CENTER);
  play = false;
  bg = loadImage("cartina.png");
  presence = loadImage("cartina_presence.jpg");
  silvia = new Person("silvia.png");
  erika = new Person("erika.png");
  a = loadImage("a.png");
  b = loadImage("b.png");
  c = loadImage("b.png");
  d = loadImage("a.png");
  phone = loadImage("phone.png");
  light_oriz = loadImage("light_oriz.png");
  light_vert = loadImage("light_vert.png");
  start = loadImage("start.png");
  checkA = checkB = checkC = checkD = checkPhone =  true;
  path = new String[1000];
  indexPath = 0;
  // posizioni iniziali
  silvia.x = 160;
  silvia.y=484;
  erika.x=130;
  erika.y=484;
  minim = new Minim(this); // new Minim object  
  telephone = minim.loadFile("telephone.mp3");
  pickUp = minim.loadFile("pickUp.wav");
  ghost = minim.loadFile("ghost.mp3");
  audioguida = minim.loadFile("guida.mp3");
  busyPhone = minim.loadFile("busyphone.mp3");
  ora = false;
  bg2 = loadImage("bg.jpg");
  y = loadImage("y.png");
  n = loadImage("n.png");
  ok = loadImage("ok.png");
  giorno = loadImage("day.png");
  notte = loadImage("night.png");
}

void draw(){
  
  if(play){
    image(bg,336,400); 
    image(a,300,450);
    image(b,320,450);
    image(c,510,150);
    image(d,530,150);
    checkA();
    checkB();
    checkC();
    checkD();
    checkPhone();
    silvia.drawPerson();
    erika.drawPerson();
    checkIncident();
    
    image(phone,336,320);
    
    if(ora){
      image(notte, width-80, 50);
    }
    else{
      image(giorno, width-80, 50);
    }
    
  }
  else{
    image(start,320,400);
    if(mousePressed){ play = true; }
  }
  
}


void keyPressed(){


    
      if(ora){
        if(numIn-numOut==1){
          if(silvia.isNearPhone() || erika.isNearPhone()){
            busyPhone.play();
            busyPhone.rewind();
          }
        }
        else{
          if(silvia.isNearPhone() || erika.isNearPhone()){
            audioguida.play();
            audioguida.rewind();
          }
        }
      }
      else{
          if(silvia.isNearPhone() || erika.isNearPhone()){
            audioguida.play();
            audioguida.rewind();
          }
      }
         
}


void mousePressed(){

  if(mouseX > 530 && mouseX <570 && mouseY > 35 && mouseY < 70){
    ora = false;
  }
  if(mouseX > 590 && mouseX <615 && mouseY > 35 && mouseY < 70){
    ora = true;
  }
  
}

